
(function (global, amplify, undefined) {
	var lastReadId = 0;
	
	var scrollPages = [];
	var scrollHMenu = [];
	var scrollNews = [];
	
	var mobileMenu = [];
	var pageId;
	var currentMsgClass = "";
	var isDebug;
	var appStart = true;
	var dataLoaded = false;
	var disableCache;
	var orientation;
	var lockRotation;
	
	var locl = global.locl = {
		version: "2.0",
		stillLoading: false, //still loading info for rotation espacially
		DownloadCache: 0, // count up for batch start, count down for ready states
		AppTitle: "FF Info OOE",
		scrollOffset: 90,
		lastPage: "",
		init: function (isDebug, disableCache) {
			locl.isPageReady = false;
			locl.isDebug = isDebug;
			locl.disableCache = disableCache;
			locl.isPhoneGap = (typeof PhoneGap !== "undefined");
			locl.iOS = (/iphone|ipad/gi).test(navigator.appVersion);
			locl.android = (/android/gi).test(navigator.appVersion);
			locl.windows = (/windows phone 8/gi).test(navigator.appVersion);
			locl.blackberry = window.blackberry;
			locl.nokia = navigator.userAgent.indexOf("Nokia") > -1;
			locl.isMobile = locl.iOS || locl.android || locl.blackberry || locl.nokia;
			locl.operamini = navigator.userAgent.indexOf("Opera Mini") > -1;
			
			$.mobile.defaultPageTransition = 'slide';
			//$.mobile.page.prototype.options.domCache = false;

			amplify.store.error = function() {locl.storeError();};

			amplify.subscribe("settings.ready", onSettingsReady);
			amplify.subscribe("page.ready", pageReady);
			amplify.subscribe("app.data.error", systemError);
			amplify.subscribe("app.data.parsererror", systemParserError);

			amplify.subscribe("app.page.online", pageStartOnline);
			amplify.subscribe("app.page.offline", pageStartOffline);

			amplify.publish("core.init");
			amplify.publish("user.init");			
			
			var toolbarHeight = $("#toolbar").height();
			locl.scrollOffset = toolbarHeight;
			
		},
		downloadReady: function() {
			debug( "main dl ready");
			if( !locl.doNotCloseSlider ) locl.hideLoading();
			locl.infoOffline();
			locl.pages.entries.render();

		},
		refreshLoader: function() {},
		checkData: function( data, error, source ) {
			if( !data ) {
				locl.parseError(data, error, source);
				return false;
			}
			if ( data.status === "fail" || data.status === "error" ) {				
				debug("decoder:error");
				amplify.publish( "app.data.error" );
				return false;
			}
			return true;
			
		},
		checkItem2: function( lidx ) {

			$("#check1", "#" + locl.pageId).val( 0 );
			$("#check2", "#" + locl.pageId).val( 0 );
			$("#check3", "#" + locl.pageId).val( 0 );

			$(".check1", "#" + locl.pageId ).attr( "src", "templates/mobile/btn_check.png" );
			$(".check2", "#" + locl.pageId ).attr( "src", "templates/mobile/btn_check.png" );
			$(".check3", "#" + locl.pageId ).attr( "src", "templates/mobile/btn_check.png" );
			
			locl.checkItem( lidx, "" );
			
		},
		checkItem: function( lidx, pg ) {	
			var obj = $(".check" + lidx, "#" + locl.pageId );
			
			if( obj.attr("src").indexOf( "btn_check.png" )>-1 ) {
				//check
				obj.attr( "src", "templates/mobile/btn_check_checked.png" );
				$("#check" + lidx, "#" + locl.pageId).val( 1 );
			} else {
				//uncheck
				obj.attr( "src", "templates/mobile/btn_check.png" );
				$("#check" + lidx, "#" + locl.pageId).val( 0 );
			}
			
		},
		showPopup: function( what ) {
			if( what=="beraterinfo" ) {
				
				var data = locl.db.getRecordPage( "info_trinkverhalten" );
				if( data ) $("#beraterinfo .body").html( data.content.replace( /__/g, '"' ) );
				
			}
			
			if( what=="impressum" ) {
				
				var data = locl.db.getRecordPage( "impressum" );
				if( data ) $("#impressum .body").html( data.content.replace( /__/g, '"' ) );
				
			}
			if( what=="beraterregisterinfo") {
				var data = locl.db.getRecordPage( "trinkberater_willkommen" );
				if( data ) $("#beraterregisterinfo .body").html( data.content.replace( /__/g, '"' ) );
				
			}
			
			
			$("#overlay").css( {visibility:"visible", display:"block"} );
			$("#" + what).css( {visibility:"visible", display:"block"} );
			
			if( what=="beraterinfo" ) {
					
				
				setTimeout( function() {
					locl.pages.berater.overlayScroll.refresh();
					locl.pages.berater.overlayScroll.scrollTo(0,0,0);
				}, 1);
	

				
			}
			
			
		},
		closePopup: function( what ) {
			
			$("#overlay").hide();
			$("#" + what).hide();

		},
		closePopup2: function( what ) {
			$("#" + what).hide();

		},
		storeError: function() {
			locl.msg( "", "Daten konnten nicht gespeichert werden!" );
			locl.hideLoading();
			locl.infoOffline();
			locl.iScrollRefresh();
		},
		onRefreshClick: function() {
			locl.stillLoading = false;
			locl.doNotCloseSlider = false;

		},
		checkRootpath: function() {
			old_fs = locl.db.getRootpathOld();
			if( old_fs==undefined ) old_fs="";
			
			fs = locl.rootFS;
			if( fs==undefined ) fs = "";
			if( old_fs=="" && fs=="" ) return;
			
			if( old_fs=="" ) {
				old_fs=fs;
				locl.db.saveRootpathOld( fs );
			}
						
			if( old_fs!=fs ) {
				locl.db.saveRootpathOld( fs );
				
				locl.showLoading( g("_LANG_LOADING") );
				locl.hideLoading();
			}
		},
		initPreload: function() {
			locl.isPageReady = true;

			//preload iscroll

			setTimeout( function() {
				$(".page").each(function(){
					if( $("#" + this.id + " .vscrollable" ).length>0 && this.id!="page" ) locl.vScrollCreate( this.id, "wrapper" + this.id );
				});
				locl.connector.checkData( true );
			}, 100 );

			
			
		},
		fsReady: function( fs ) {
			debug("set rootfs to " + fs );
			if( fs=="" ) {
				locl.showLoading( "Daten werden geladen" );
				locl.pages.entries.render();
				return;
			}
			locl.setRootFS( fs );
			
			locl.pages.settings.load();
			
			//if( !locl.isPhoneGap && locl.isMobile ) setBackupDir();
			locl.pages.settings.load();
			
			locl.isPageReady = true;
			
			//preload iscroll
			$(".page").each(function(){
				if( $("#" + this.id + " .vscrollable" ).length>0 && this.id!="page" ) locl.vScrollCreate( this.id, "wrapper" + this.id );
			});

			setTimeout( function() {
			locl.connector.checkData( true );
			}, 100 );

			
			
		},
		setRootFS: function( fs ) {
			locl.rootFS = fs;
			locl.db.saveRootpath();
		},
		getRootFS: function() {
			var fs = locl.rootFS;
			if( fs==undefined || fs=="" ) {
				fs = locl.db.getRootpath();
				return fs;
			}
			return fs;
		},
		confirm: function(msg, title, callback ) {
			if( locl.isPhoneGap || !locl.isMobile ) {
				if( confirm( msg ) ) {
					amplify.publish( callback );
				}
				return;
			}
			
			var ret = navigator.notification.confirm(msg, 
				function( button ) {
					if( button==1 ) amplify.publish( callback );
				}, 
				title, g("_LANG_YES")+","+g("_LANG_NO") );
			

		},
		confirm2: function(msg, title, callback ) {
			if( locl.isPhoneGap || !locl.isMobile ) {
				if( confirm( msg ) ) {
					amplify.publish( callback );
				}
				return;
			}
			
			var ret = navigator.notification.confirm(msg, 
				function( button ) {
					if( button==2 ) amplify.publish( callback );
				}, 
				title, "Abbrechen"+","+"Weiter" );
			

		},
		confirm3: function(msg, title, callback ) {
			if( locl.isPhoneGap || !locl.isMobile ) {
				alert( msg )
				amplify.publish( callback );
				return;
			}
			
			var ret = navigator.notification.alert(msg, function() { amplify.publish( callback ); }, title, "Ok" );
			

		},
		alert: function(msg, title, callback ) {
			if( locl.isPhoneGap || !locl.isMobile ) {
				alert( msg );
				amplify.publish( callback );
				return;
			}
			
			var ret = navigator.notification.confirm(msg, 
				function( button ) {
					amplify.publish( callback );
				}, 
				title, "OK" );
			

		},
		infoOnline: function( msg ) {
			return;
			$("#loading_overlay").css({
					display:"block",
					visibility: "visible"
				});
			if( msg=="" || msg==undefined ) return;
			
			var text = g("_LANG_DATA_LOADING_MSG");
			if( msg!="" ) text = text + ": " + msg;
			
			$("#loading_overlay").html( text ); //"Daten werden geladen: " + msg );
			
		},
		infoOffline: function() {
			$("#loading_overlay").hide();
			$(".fullbackground").show();
		},
		nScrollRefresh: function() {
			var scroller = scrollHMenu[locl.pageId];
			if( scroller ) {
				setTimeout( function() {
					scroller.refresh();
					scroller.scrollTo( 0,0,0 );
				}, 100);
			}

		},
		getPageScroller: function() {
			return scrollPages[$.mobile.activePage.attr("id")];
		
			
		},
		iScrollReset: function() {
			var scroller = locl.getPageScroller();
			if( scroller ) scroller.scrollTo( 0,locl.scrollOffset,100 );
		},
		iScrollRefresh: function (pageId, skipScrollTop) {
			if (!pageId) pageId = locl.pageId
			if( pageId==undefined ) pageId=="page";
			debug("iScrollRefresh" + pageId);
						
			setTimeout(function () {
				if (pageId in scrollPages) {
					var scroller = scrollPages[pageId];
					if (scroller) {
						scroller.refresh();
						if (skipScrollTop === true) {
							return
						}
						if (scroller.y < -200 || scroller.x <-200) {
							scroller.scrollTo(0, locl.scrollOffset, 200 )
						}
					}
				} else {
					/*setTimeout(function () {
						locl.iScrollRefresh(pageId, skipScrollTop)
					},
					250)*/
				}
			},
			0)
			
		},
		msg: function (title, message, className, callback) {
			$(".status-msg h3", "#status").html( locl.AppTitle );
			$(".status-msg p", "#status").html(message);
			
			$("#status").removeClass(currentMsgClass).addClass(className).slideDown("fast", function () {
				setTimeout(function () {
					$("#status").slideUp("normal", function () {
					})
				},
				2000)
			});
		},
		networkError: function () {
			locl.msg( g("_LANG_NETWORK_ERROR"), g("_LANG_ERR_ESTABLISH"), "error");
		},
		progress: function( perc ) {
			$("#loading_bar").css( {visibility:"visible", display:"block"} );
			$("#loading_bar .progress").css( {width:perc + "%"} );
		},
		testLoader: function() {
			locl.showLoading( "Daten werden geladen: Newsvideos" );
			locl.progress( 40 );
		},
		showLoading: function ( msg ) {
			
			setTimeout( function() {
				
				locl.stillLoading=true;
				$("#overlay").show();
				
				if( msg=="" || msg==undefined ) msg=g("_LANG_LOADING");
					
				locl.lastLoadingMsg = msg;	
				
				$.mobile.loading( "show" );
				$(".ui-loader").css( {"visibility":"visible"});
			}, 200);	
		},
		hideLoading: function() {
			setTimeout( function() {
				
				locl.stillLoading = false;
				
				$("#overlay").hide();
				$("#loading_bar").hide();
				$.mobile.loading( "hide" );
				
			}, 200);
		},
		IsOnline: function( responseCall, errorCall) {		
			/*amplify.publish( errorCall );
			return;*/
			
			if( locl.isPhoneGap || !locl.isMobile ) {
				amplify.publish( responseCall );
				return;
			}
			$.support.cors = true;
			$.ajax({
				type: "GET",
				data: "{}",
				url: locl.config.pingURL,
				cache: false,
				timeout: 10000,
				success: function(response) {
					debug("IsOnline.Ajax: true");
					amplify.publish( responseCall );
				},
				error: function(xhr, textStatus, errorThrown) {
					debug("IsOnline.Ajax: false");
					amplify.publish( errorCall );
				}
			});
			
		},
		openGeo: function( address ) {
			window.location.href= "geo:0,0?q=" + address;
		},
		openURL: function( url ) {
			
			//if( locl.isPhoneGap || !locl.isMobile ) {
			//	window.location.href = url ;
			//} else {
				/*window.plugins.childBrowser.onLocationChange = onChildBrowserLocationChange;
				window.plugins.childBrowser.showWebPage( url, { showLocationBar: true });*/
				window.open( url, "_blank" );
			//}
			
		},
		onJSONError: function( msg ) {		
			locl.hideLoading();
			
			if( msg=="" || msg==undefined ) msg =g("_LANG_NO_INTERNET");// "Keine Internetverbindung verf&uuml;gbar!";
			locl.msg( "error", msg );
			
			locl.iScrollRefresh();
	
			
		},
		updateCSSForPageDetail: function() {
			debug( "calling updateCSSForPageDetail" );

		},
		setTemplate: function( newTemplate, lockRotation ) {
			locl.template = newTemplate;
			
			locl.lockRotation = lockRotation;
			debug( "setTemplate " + newTemplate + "/" + lockRotation );
			
			
			//fix for android?
			//used in windows?
			//$(".ui-mobile, .ui-mobile-viewport, .ui-page, .page").css( {width:gSysWidth() + "px",height:gSysHeight() + "px"} );

			locl.language.loadFix();			
			locl.pages.callFunction(pageId, "open");
			
			setTimeout( function() {
				pageChanged();					 
			}, 500 );
			

		},
		setOrientation: function( newVal ) {
			debug("setOrientation " + newVal );
			//beim ipad: stehend 90/-90 liegend; 0/180 stehend
			switch(newVal) {  
			  case -90:
			  case 90:
			  case "landscape":
			  	locl.orientation = 'landscape';
				break; 
			  default:
				locl.orientation = 'portrait';
				break; 
			}
		},
		parseError: function(data, error, source) {
			var errorMessage = "";
			debug("parseError:start " + source);
			
			if (data && data.error && $.trim(data.error).length > 0) {
				errorMessage = data.error
			}
			if ($.trim(errorMessage).length == 0) {
				errorMessage = g("_LANG_ERROR_LOADING_DATA"); //"Daten konnten nicht geladen werden. Bitte versuchen Sie es zu einem sp&auml;teren Zeitpunkt erneut! " + source
			}
			amplify.publish( "app.data.parsererror", errorMessage );
	
		},
		pageChanged: function() {
			pageChanged();	
		},
		gotoPage: function( obj, pg ) {
			locl.pressButton( obj );
			
			setTimeout( function() {
				$.mobile.changePage( "#" + pg );
				locl.resetButton( obj );
			}, 100);
		},
		refreshNewsScroller: function() {
			if( $.mobile.activePage.find(".nscroller").length==0 ) return;
			if( !scrollNews["page"] )  return;
			
			
			//destroy hscroller
			var scroller = scrollHMenu["page"];
			scroller.destroy();
			scrollHMenu["page"] = null;
			
			for( var i=0; i<$.mobile.activePage.find(".nscroller").length; i++ ) {	
				var scroller = scrollNews["page"][i];			
				if( scroller ) {
					scroller.destroy();
					scrollNews["page"][i]=null;
				}
			}
			
			//recreate
			locl.nScrollCreate( "page" );
			locl.hScrollCreate( "page" );
		},
		hScrollCreate: function( pageId, obj) {

			scrollHMenu[pageId] = new iScroll( $.mobile.activePage.find(".hscrollable")[0].id , {
				hScroll: true,
				vScroll: false,
				snap: "td",
				bounce: true,
				momentum: false,
				scrollbarClass: "iScrollbar",
				onScrollEnd: function () {
					this.refresh();
					if( locl.pageId==undefined || locl.pageId=="page" ) {
					
					var newWidth = $("#page .hscrollable").width();
					
					var lidx = this.x/newWidth;
					lidx=((lidx*-1)+1).toFixed(0);
					
					$(".point_set .inner div").removeClass( "pointsel" );
					$(".point_set .inner .item_" + lidx ).addClass( "pointsel" );
						
					}
					
				}

			});	
			
		},
		nScrollCreate: function( pageId, obj ) {
			if( pageId==undefined ) pageId="page";
			
			for( var i=0; i<$.mobile.activePage.find(".nscroller").length; i++ ) {	
				if( !scrollNews[pageId] ) scrollNews[pageId] = [];
					
					if( !scrollNews[pageId][i] ) {
						if( $.mobile.activePage.find(".nscroller")[i].id ) {
							scrollNews[pageId][i] = new iScroll($.mobile.activePage.find(".nscroller")[i].id, {
								hScroll: false,
								vScroll: true,
								hScrollbar: false,
								vScrollbar: true,
								fixedScrollbar: true,
								fadeScrollbar: false,
								hideScrollbar: true,
								scrollbarClass: "iScrollbar",
								onScrollEnd: function() {
									this.refresh();	
								}
							});
						}
					}	
			}

		},
		vScrollCreate: function( pageId, obj ) {
			var pullDownEl;
			
			var pullDownOffset = locl.scrollOffset*-1;
			
			if ($(".scroller-pulldown", "#" + pageId).length > 0) {
				pullDownEl = $(".scroller-pulldown", "#" + pageId)[0];
				pullDownOffset = $(".scroller-pulldown", "#" + pageId)[0].offsetHeight;
			}
			
			var hideScrollbar = locl.iOS;
			
				if(!scrollPages[pageId]) {
					ScrollToTop = false;
					scrollPages[pageId] = new iScroll(  obj, {
						useTransition: false,
						topOffset: pullDownOffset,
						hScroll: false,
						vScroll: true,
						hScrollbar: false,
						vScrollbar: false,
						hideScrollbar: true,
						onBeforeScrollStart: function (e) {							
							var target = e.target;
							while (target.nodeType != 1) {
								target = target.parentNode
							}
							if (target.tagName != "SELECT" && target.tagName != "INPUT" && target.tagName != "TEXTAREA" && e.target.tagName != "BUTTON") {
								e.preventDefault();
								e.stopPropagation()								
							}
								
							
							
							/*var obj = $(".vscrollable", "#" + locl.pageId);
							var offset = obj.scrollTop();
							//NUR wegen Editieren!
							if( offset!=0 && offset!=undefined ) {
								obj.scrollTop( 0 );
								this.scrollTo( 0, (offset*-1), 0 );
							}*/
							
							
						},
						
						onRefresh: function () {
							if (pullDownEl && pullDownEl.className.match("loading")) $(pullDownEl).removeClass("loading");
						},
						onScrollMove: function () {
							if (pullDownEl) {
								if (this.y > 15 && !$(pullDownEl).hasClass("flipped")) {
									$(pullDownEl).addClass("flipped");
									this.minScrollY = 0
								} else {
									if (this.y < 15 && $(pullDownEl).hasClass("flipped")) {
										$(pullDownEl).removeClass("flipped");
										this.minScrollY = -pullDownOffset
									}
								}
							}
							this.topOffset = this.minScrollY;
						},
						onScrollEnd: function () {
							if (pullDownEl && $(pullDownEl).hasClass("flipped")) {
								$(pullDownEl).removeClass("flipped").addClass("loading");
								
								amplify.publish( locl.pageId + "-scroller-pulldown")
							} else {
								this.refresh();	
							}
							
						}
					});
					
					//locl.hideLoading();
					$("#overlay").hide();
					$("#overlay").css( "background-color", "rgba(0,0,0,0.8)" );
					debug( "Scroller Timeout" );
					
					setTimeout( function() {
						scrollPages[pageId].refresh();
						scrollPages[pageId].scrollTo(0,locl.scrollOffset,0);
					 }, 1);

				} else {
					//scrollPages[pageId].refresh();
					//scrollPages[pageId].scrollTo(0,0,0);
					
					$(".vscrollable", "#" + locl.pageId).scrollTop(0);
				}				
				
		}
	};
	
	
	function onDeviceReady() {
		locl.isPhoneGapReady = true;

		if (ChildBrowser && ChildBrowser.install) {
			locl.childBrowser = ChildBrowser.install()
		}
		
		
	}

	function onSettingsReady() {	
		$(document).delegate("[data-role='page']", "pageshow", pageChanged );
		//$("[data-role='page']").live( "pagebeforehide", function( e, ui ) {pageLoad( e, ui );} );
		$("[data-role='page']").on( "pagebeforehide", ".page", function( e, ui ) {pageLoad( e, ui );} );

	}
	
	function onChildBrowserLocationChange(loc) {
		if (loc.indexOf("about:blank") >= 0)
			window.plugins.childBrowser.close();
	}
	function onChildbrowserClose() {
			
	}
	function systemError( msg ) {
		locl.hideLoading();
		
		if( !msg ) msg = g("_LANG_NO_INTERNET"); //"Keine Internetverbindung verf&uuml;gbar!";
		locl.msg( "", msg, "error" );
		
		locl.infoOffline();
		locl.iScrollRefresh();

	}
	function systemParserError( msg ) {
		locl.hideLoading();
		
		if( !msg ) msg = g("_LANG_NO_INTERNET"); //"Keine Internetverbindung verf&uuml;gbar!";
		locl.msg( "", msg, "error" );

		locl.db.saveEntries("");
		locl.pages.entries.render();
		
		locl.infoOffline();
		locl.iScrollRefresh();

	}
	function pageLoad( e, ui ) {
		return;
		var id = ui.nextPage.attr("id");

		if( id==undefined ) return;		
		locl.pages.callFunction(id, "open");
	}
	function pageChanged() {
		
		locl.pageId = $.mobile.activePage.attr("id");
		var pageId = locl.pageId;
		var ScrollToTop = true;
		locl.pages.callFunction(pageId, "opened");

		var hideScrollbar = locl.iOS;
		if ($.mobile.activePage.find(".vscrollable").length > 0) {
			setTimeout( function() {
				locl.vScrollCreate( pageId, $.mobile.activePage.find(".vscrollable")[0].id );
			}, 100);	
		}
				
		
		$(".ui-loader").css( {"top":"40%"} );
		locl.pages.callFunction(pageId, "ready");
		amplify.publish("page.ready");		

	}
	
	function pageStartOnline() {
		
	}
	
	function pageStartOffline() {
		return;
		setTimeout( function() {
			locl.msg( "", g("_LANG_SYSTEM_OFFLINE_RELOAD") );
			locl.infoOnline( g("_LANG_SYSTEM_OFFLINE_RELOAD") );
			
			locl.hideLoading();
		 }, 1600);
		
		
		locl.doNotCloseSlider = false;
		setTimeout( function() {
		locl.pages.news.render();
		}, 100 );
	}
	
	function pageReady() {		
	}
	
} (this, amplify));




(function (locl, undefined) {
	var config = locl.config = {
		appId: 1,
		serverUrl: "http://www.cmaxmedia.com/",
		baseAPIUrl: "http://www.cmaxmedia.com/mobile/ffoe/",
		pingURL: "http://www.cmaxmedia.com/ping.html"

	}
} (locl));





(function (locl, $, amplify, undefined) {
	var registeredPages = {};
	var currentPage = false;
	var appPages = [
	{id: "page"},
	{id: "entries"},
	{id: "entriesdetail"},
	{id: "settings"},
	{id: "setup"}
	];
	var pages = locl.pages = {
		register: function (name, instance, secure) {
			registeredPages[name] = {
				name: name,
				instance: instance,
				secure: secure
			}
		},
		getByName: function (name) {
			var page = registeredPages[name];
			if (page && page.instance) {
				return page
			}
			return null
		},
		callFunction: function (name, functionNames, value) {
			var page = pages.getByName(name);

			if (page && functionNames) {
				if ($.isArray(functionNames)) {
					for (var i = 0; i < functionNames.length; i++) {
						var functionName = functionNames[i];
						page.instance[functionName] && page.instance[functionName].call(page.instance, value)
					}
					if ($.inArray("open", functionNames) > -1) {
						currentPage = page;
						amplify.publish("page.open", {
							page: name
						})
					}
				} else {
					var functionName = functionNames;
					
					page.instance[functionName] && page.instance[functionName].call(page.instance, value);
						
					if (functionName == "opened") {
						currentPage = page;
						amplify.publish("page.open", {
							page: name
						})
					}
				}
			}
			return true
		},
		addFooters: function (isInit) {
			for (var i = 0; i < appPages.length; i++) {
			}
		}
	};
	
	function onPageOpen(data) {
		var pageName = data.page;
	}

	amplify.subscribe("page.open", onPageOpen);

} (locl, jQuery, amplify));










(function (locl, amplify, undefined) {
	var page = locl.pages.page = {
		transferOnNextTime: false,
		opened: function (params) {
			$("#toolbar h1").html( locl.AppTitle );
			locl.lastPage = "page";
			
			if(locl.isPageReady==false) return;
			
			//locl.pages.entries.render();

			if( locl.pages.page.transferOnNextTime==true) {
				locl.connector.sendData();
				
				locl.pages.page.transferOnNextTime = false;
			}
		}
		
	};   

	locl.pages.register("page", page);
} (locl, amplify));






(function (locl, amplify, undefined) {
	var page = locl.geo = {
		retPage: "",
		geoGet: function( lp ) {
			locl.geo.retPage = lp;
			getGEOPosition();	
		},
		onGeoErr: function( e ) {
			locl.msg( "", "Fehler bei der Positionsbestimmung", "error" );
			locl.hideLoading();
		},
		geoRet: function( lon, lat ) {
			locl.db.savePosition( lon, lat );			
			locl.pages.nearme.geoRet();
			
		},
		getGoogleMap: function( e, n ) {
			var html = 'http://maps.googleapis.com/maps/api/staticmap?center=&zoom=13&size=600x300&maptype=roadmap&markers=color:blue%7Clabel:S%7C'
				+ n + ',' + e + ''//'40.702147,-74.015794'
				+ '&markers=color:green%7Clabel:G%7C'
				+ n + ',' + e + ''//'40.711614,-74.012318'
				+ '&markers=color:red%7Ccolor:red%7Clabel:C%7C'
				+ n + ',' + e + '' //'40.718217,-73.998284'
				+ '&sensor=false';	
				
			//html = "images/staticmap.png";
			return html;
		},
		getGoogleLink: function( e, n ) {
			//reset before loading

			var html = 'https://www.google.at/maps/place/' + n + 'N+' + e + 'E/@' + n + ',' + e + 'z/data=!3m1!4b1!4m2!3m1!1s0x0:0x0';
			return html;
		}
		
	};   
} (locl, amplify));



(function (locl, amplify, undefined) {
	var page = locl.pages.nearme = {
		init: function() {
			amplify.subscribe("app.nearme.receive", onConnectorReceive);	
			amplify.subscribe("app.nearme.receivestatus", onConnectorReceiveStatus);	
			amplify.subscribe("app.nearme.offline", onSystemOffline);	
			amplify.subscribe("app.nearme.error", onSystemError);	
		},
		geoRet: function() {
			
			locl.IsOnline( "app.nearme.receive", "app.nearme.offline" );	
		},
		opened: function (params) {
			$("#toolbar h1").html( "In meiner Nhe" );
			locl.lastPage = "nearme";
		},
		show: function() {
			$.mobile.changePage( "#nearme" );	
			
			setTimeout( function() { locl.pages.nearme.checkData(); }, 100);
		},
		goBack: function() {
			$.mobile.changePage( "#page", {transition:"slide",reverse:true} );	
			
		},
		checkData: function() {
			locl.showLoading( "Daten werden geladen..." );

			//geodaten holen
			locl.geo.geoGet( "nearme" );
			
		},
		receiveData: function() {
			locl.IsOnline( "app.nearme.receive", "app.nearme.offline" );	
		},
		render: function() {render();}
	};   

	function onFeed1() {}

	function onSystemError() {}	
	function onConnectorReceiveStatus( data ) {
		locl.db.saveEntriesNearMe( data );
		
		locl.pages.nearme.render();
	}

	function onConnectorReceive( data ) {
		amplify.request({
				resourceId: "app.nearme.receive",
					data: {
					appId: locl.version,
					lon: locl.db.getPosition( "lon" ),
					lat: locl.db.getPosition( "lat" )
				},
					success: function (data) {
					debug("app.nearme.get");
					amplify.publish("app.nearme.receivestatus", data);
				},
					error: function (msg) {
					debug("error connector");
					amplify.publish("app.nearme.error")
				}
			}
		);
		
	}
	
	function onJSONError( msg ) {
		locl.onJSONError( msg );
	}
	
	function onSystemOffline( msg ) {
		locl.pages.nearme.render();
		locl.onJSONError( "Keine Internetverbindung" );
	}
	
	
	
	function render( append ) {
		if( locl.disableCache ) return;
		var html = "";
		var data = locl.db.getEntriesNearMe();	
		if( !checkData( data ) ) {
			var err_html = "";
			err_html = '<ul class="items error">'
					+ '<li style="text-align:center" onclick="locl.pages.nearme.checkData();">Klicken Sie hier, um die Liste zu aktualisieren</li>'
					+ '<li style="text-align:center" onclick="locl.err.alert();">Sie glauben es handelt sich um eine Strung?</li>'
					+ '</ul>';
			
			render_done( err_html );
			return; 
		}
			
		var perpage = 30;
		var aktoffset = locl.pages.entries.offset;
		
		var lastId = locl.db.getLastId();
		if( lastId==undefined || lastId=="" ) lastId=0;
		
		var from = (perpage * aktoffset);
		var goto = (perpage * (aktoffset+1));
		if( goto>data.length ) goto = data.length;
		
		
		if( aktoffset>=1 && !append ) html += '<li onclick="locl.pages.entries.loadPrev();" class="removeme2"><div align="center">Vorigen ' + perpage + ' laden</div></li>';


		for (var i = from; i<goto; i++) {				
			var item = data[i];
			var checked = 'btn_check';
			var classext = "";
			
			
			var icount = item.count;
			if( icount==undefined ) icount=0;
			
			var readstate = (item.id > lastId) ? " unread" : "";			
			var itemhtml = "";
			
			if( item.werbung=="1" ) {
				itemhtml = '<li class="item' + item.id + classext + '" onclick="locl.openURL(' + "'" + item.link + "'" + ');">'
					+ '<div class="check"></div><div class="title">' + item.bezirk + '<span class="small counter'+item.id+'"><br />' + item.name + '</span></div><div class="clr"></div>'
					+ '</li>';
				
			} else {
				var clickHtml=' onclick="locl.pages.entries.editItem(' + item.id + ');"';
				itemhtml = '<li class="item' + item.id + classext + '' + readstate + '">'
					+ '<div class="check"'+clickHtml+'>' + item.date
					+ '</div><div class="title"'+clickHtml + '>' + item.name + '<span class="small counter'+item.id+'"><br />' + item.bezirk + '</span></div><div class="clr"></div>'
					+ '</li>';
			}
		
			html += itemhtml;
			
		}
				
			
		if( goto<data.length ) html += '<li onclick="locl.pages.entries.loadNext();" class="removeme"><div align="center">Nchsten ' + perpage + ' laden</div></li>';
		
		if( append==true ) {
			$(".inner-scroller .innerhtml li.removeme", "#" + $.mobile.activePage.attr("id") ).remove();
			$(".inner-scroller .innerhtml ul", "#" + $.mobile.activePage.attr("id") ).append( html );
			
			//refresh scroller
			var scroller = locl.getPageScroller();
			if( scroller ) scroller.refresh();
			locl.hideLoading();
			return;
		}


		render_done( '<ul class="items">' + html + '</ul>' );
		
	}
	
	function render_done( html ) {
		$(".inner-scroller .innerhtml", "#nearme" ).html( html );

		setTimeout( function() {
		var scroller = locl.getPageScroller();
			if( scroller ) scroller.refresh();
		}, 100);
		
		if( !locl.doNotCloseSlider ) locl.hideLoading();	
	}
	$(document).bind("mobileinit", function () {
		locl.pages.nearme.init();
	})
	locl.pages.register("nearme", page);
} (locl, amplify));








(function (locl, amplify, undefined) {
	var page = locl.pages.settings = {
		init: function() {
			amplify.subscribe("page.settings.deleteall", onDeleteAll);
		},
		load: function() {
			var settings = locl.db.getSettings();
			
			if( settings ) {
				if( settings.PageColor!="" ) locl.pages.settings.setCol( settings.PageColor );
			}
			
		},
		save: function() {
			
			$.mobile.changePage( "#page", {transition: "flip", reverse: true} );
			
		},
		setup: function() {
			
			$.mobile.changePage( "#setup", {transition: "slide"} );
			locl.pages.setup.opened();
			
		},
		showSettings: function() {
			locl.pages.settings.updateCol();
			
			$.mobile.changePage( "#settings", {transition: "flip"} );
			locl.pages.settings.opened();
			
		},
		opened: function() {
			$("#toolbar h1").html( "Einstellungen" );	
			
		},
		updateCol: function() {
			
			var settings = locl.db.getSettings();
			$(".apc").removeClass( "selected" );
			
			if( settings==undefined || settings.PageColor==undefined) {
				$(".appcol3").addClass( "selected" );	
			} else {					
				$(".appcol" + settings.PageColor ).addClass( "selected" );	
			}
		},
		switchCol: function( lidx ) {
			var settings = locl.db.getSettings();
			if( !settings ) settings = new Array();
			
			locl.pages.settings.updateCol();
			
			var colors = locl.db.getColors();
			var col = colors[lidx-1];

			settings.PageColor = col;
			locl.db.saveSettings( settings );
			
			locl.pages.settings.setCol( col );
			
		},
		setCol: function( col ) {
			$(".innerpage2, .innerpage").css( { backgroundColor: col } );

		},
		readAll: function() {
			
			var data = locl.db.getEntries();
			if( !checkData( data ) ) {
				$.mobile.changePage( "#page", {transition: "flip", reverse: true} );
				return;
			}
			
			var read = new Array();

			for( var i=0; i<data.length; i++ ) {
				read.push( {id:data[i].id} );
			}
			
			$("#page li").removeClass("unread");
			
			locl.db.saveReadEntries( read );
			$.mobile.changePage( "#page", {transition: "flip", reverse: true} );
		},
		copy: function() {
			
			locl.openURL( "http://www.cmaxmedia.com" );	
		},
		deleteAll: function() {
			locl.confirm( "Alle Daten lschen?", "FFInfo", "page.settings.deleteall" );
			
		}
	};   

	function onDeleteAll() {
		locl.db.clearAll();
		
	}
	
	locl.pages.register("settings", page);
	$(document).bind("mobileinit", function () {locl.pages.settings.init();})

} (locl, amplify));










(function (locl, amplify, undefined) {
	var connector = locl.connector = {
		init: function() {
			amplify.subscribe("app.connector.send", onConnectorSend);	
			amplify.subscribe("app.connector.sendstatus", onConnectorSendStatus);	
			amplify.subscribe("app.connector.receive", onConnectorReceive);	
			amplify.subscribe("app.connector.receivestatus", onConnectorReceiveStatus);	
			amplify.subscribe("app.connector.offline", onSystemOffline);	
			amplify.subscribe("app.connector.error", onSystemError);	
			
		},
		checkData: function( ival ) {
			locl.showLoading( "Daten werden geladen..." );

			//locl.pages.entries.render();
			locl.IsOnline( "app.connector.receive", "app.connector.offline" );	

			
		},
		sendData: function() {
			locl.IsOnline( "app.connector.send", "app.connector.offline" );	
		},
		receiveData: function() {
			locl.IsOnline( "app.connector.receive", "app.connector.offline" );	
		},
	};
	function onFeed1() {}

	function onConnectorSend() {
		var data = locl.db.getEntries();
		
		amplify.request({
				resourceId: "app.connector.send",
					data: {
					appId: locl.version,
					data: JSON.stringify( data )
				},
					success: function (data) {
					debug("app.connector.get");
					amplify.publish("app.connector.sendstatus");
				},
					error: function (msg) {
					debug("error connector");
					amplify.publish("app.connector.error")
				}
			}
		);

	}
	function onSystemError() {
	}
	function onConnectorSendStatus() {
		locl.showLoading( "Daten werden geladen" );
		locl.connector.receiveData();
	}
	
	function onConnectorReceiveStatus( data ) {
		if( !checkData( data ) ) return;
		//get the last id
		var check = locl.db.getEntries();
		var lastId =0;
		if( checkData( check ) ) {
			for( var i=0; i<check.length; i++ ) {
				if( !data[i] ) data[i]={id:0};
				
				if( data[i].id>lastId ) lastId = data[i].id;
			}	
		}
		locl.db.saveLastId( lastId );
		locl.db.saveEntries( data );
		
		locl.pages.entries.render();
		/*
		dir_array = [];
		dir_array[0] = {subdir:"ffinfo"};
		CreateDirs();
		
		locl.Downloader.init();
		downloadThumbs( data );		
		locl.Downloader.start();*/	
		
	}
	function downloadThumbs( data ) {
		locl.infoOnline("Thumbs");
		for( var i=0; i<data.length; i++ ) {
			if( data[i].image != undefined && data[i].image!="" ) {
				locl.Downloader.add( data[i].image, "ffinfo/" );
			}
		}
	}
	

	function onConnectorReceive( data ) {
		amplify.request({
				resourceId: "app.connector.receive",
					data: {
					appId: locl.version
				},
					success: function (data) {
					debug("app.connector.get");
					amplify.publish("app.connector.receivestatus", data);
				},
					error: function (msg) {
					debug("error connector");
					amplify.publish("app.connector.error")
				}
			}
		);
		
	}
	
	function onJSONError( msg ) {
		locl.onJSONError( msg );
	}
	
	function onSystemOffline( msg ) {
		locl.pages.entries.render();
		locl.onJSONError( "Keine Internetverbindung" );
	}
	$(document).bind("mobileinit", function () {
		locl.connector.init();
	})
} (locl, amplify));

	


(function (locl, amplify, undefined) {
	var dl = locl.Downloader = {
		setAsStart: function( newVal ) {
			locl.Downloader.startfile = newVal;
		},
		init: function( section ) {
			locl.Downloader.section = section;
			locl.Downloader.FileCache = [];
			locl.maxFileDownloads = 0;
			locl.DownloadCache = 0;
			locl.DownloadInfo = [];
		},
		add: function( fullFile, subDir ) {
			var record = {
				file: fullFile,
				dir: subDir
			};
			
			locl.Downloader.FileCache.push( record );
		},
		update: function() {
								 
			 locl.refreshLoader();

			var perc=(100*locl.DownloadCache);
			var akt =(perc/locl.maxFileDownloads);
			if( akt<=100 ) {
				locl.progress( akt );
				
				var msg = locl.lastLoadingMsg;
				if( msg=="" || msg==undefined ) msg = g("_LANG_LOADING");
				
				locl.showLoading( "Herunterladen (" + akt.toFixed(0) + " %)" );
			}
		},
		start: function() {
			var data = locl.Downloader.FileCache;
			if( !data ) {
				locl.Downloader.finished();
				return;
			}
			if( !data[ locl.DownloadCache ] ) {
				locl.Downloader.finished();
				return;
			}
			
			locl.maxFileDownloads = (data.length-1);
			locl.DownloadCache = 0;
			locl.infoOnline( "Start " + basename( data[ locl.DownloadCache ].file ) + " (" + locl.DownloadCache + ")" );				

			DownloadFile( data[ locl.DownloadCache ].file, data[ locl.DownloadCache ].dir );
		},
		next: function() {
			var data = locl.Downloader.FileCache;
			locl.DownloadCache++;
			
			if( locl.DownloadCache>locl.maxFileDownloads ) {
				locl.Downloader.finished();
			} else {
				locl.Downloader.update();
				locl.infoOnline( "Next " + basename( data[ locl.DownloadCache ].file ) + " (" + locl.DownloadCache + ")" );	
				//DownloadFile3( data[ locl.DownloadCache ].file, data[ locl.DownloadCache ].dir );
				
				//must be DownloadFile, not DownloadFile3, because of removing the fileentry before downloading
				DownloadFile( data[ locl.DownloadCache ].file, data[ locl.DownloadCache ].dir );
			}
			
		},
		finished: function() {
			locl.infoOnline( "Fertigstellen: " + locl.DownloadCache );

			if( locl.doNotCloseSlider ) {
				locl.connector.onDownloaderNext();	
				return;
			}			
			
			if( locl.pageId==undefined || locl.pageId=="page" || locl.pageId=="" ) {
				locl.downloadReady();
			} else {
				locl.pages.callFunction(locl.pageId, "downloadReady");	
			}
			
		}
	};
} (locl, amplify));









(function (locl, amplify, undefined) {
	var err = locl.err = {
		init: function() {
			amplify.subscribe("app.err", onFeed1);	
			amplify.subscribe("app.err.alert", onErrSend);	
			amplify.subscribe("app.err.alertstatus", onErrSendStatus);	
			amplify.subscribe("app.err.offline", onErrOffline);	
			amplify.subscribe("app.err.error", onErrError);	
			
		},
		alert: function() {
			locl.IsOnline( "app.err.alert", "app.err.offline" );	
		}
	};
	function onFeed1() {}

	function onErrSend() {	
		amplify.request({
				resourceId: "app.err",
					data: {
					appId: locl.version
				},
					success: function (data) {
					amplify.publish("app.err.alertstatus");
				},
					error: function (msg) {
					amplify.publish("app.err.error")
				}
			}
		);

	}
	function onErrError() {
	}
	function onErrSendStatus() {
		locl.msg("", "Herzlichen Dank!" );
	}
		
	function onJSONError( msg ) {
	}
	
	function onErrOffline( msg ) {
	}
	$(document).bind("mobileinit", function () {
		locl.err.init();
	})
} (locl, amplify));

	
	
	
	
(function (locl, amplify, undefined) {
	var page = locl.pages.entries = {
		itemAdd: "",
		itemNew: "",
		offset: 0,
		init:function() {
			locl.pages.entries.itemBack='<div class="back">Zurck</div><div class="clr"></div>';

		},
		downloadReady: function() {
			render();
		},
		ready: function() {},
		editItem: function( id ) {			
			locl.pages.entriesdetail.loadItem( id );
			
			setTimeout( function() {
			$.mobile.changePage( "#entriesdetail" );}, 200);

			
		},
		showList: function() {
			$.mobile.changePage( "#entries", {transition: "slide",reverse: false} );
			
		},
		goBack: function() {
			
			
			setTimeout( function() {
				$("#toolbar h1").html( locl.AppTitle );
			}, 310 );

			$.mobile.changePage( "#page", {transition: "slide",reverse: true} );
			
			
			
		},
		render: function() {
			render();
			locl.iScrollRefresh();
		},
		loadNext: function() {
			locl.pages.entries.offset++;	
			render( true );
			
		},
		loadPrev: function() {
			locl.pages.entries.offset--;
			render();
		}
		
	};   
	
	function render( append ) {
		if( locl.disableCache ) return;
		var html = "";
		var data = locl.db.getEntries();	
		if( !checkData( data ) ) {
			var err_html = "";
			err_html = '<ul class="items error">'
					+ '<li style="text-align:center" onclick="locl.db.getAll();">Klicken Sie hier, um die Liste zu aktualisieren</li>'
					+ '<li style="text-align:center" onclick="locl.err.alert();">Sie glauben es handelt sich um eine Strung?</li>'
					+ '</ul>';
			
			render_done( err_html );
			return; 
		}
			
		var perpage = 30;
		var aktoffset = locl.pages.entries.offset;
		
		var lastId = locl.db.getLastId();
		if( lastId==undefined || lastId=="" ) lastId=0;
		
		var from = (perpage * aktoffset);
		var goto = (perpage * (aktoffset+1));
		if( goto>data.length ) goto = data.length;
		
		
		if( aktoffset>=1 && !append ) html += '<li onclick="locl.pages.entries.loadPrev();" class="removeme2"><div align="center">Vorigen ' + perpage + ' laden</div></li>';


		for (var i = from; i<goto; i++) {				
			var item = data[i];
			var checked = 'btn_check';
			var classext = "";
			
			
			var icount = item.count;
			if( icount==undefined ) icount=0;
			
			var readstate = ""; //(item.id > lastId) ? " unread" : "";			
			var itemhtml = "";
			
			if( item.werbung=="1" ) {
				itemhtml = '<li class="item' + item.id + classext + '" onclick="locl.openURL(' + "'" + item.link + "'" + ');">'
					+ '<div class="check"></div><div class="title">' + item.bezirk + '<span class="small counter'+item.id+'"><br />' + item.name + '</span></div><div class="clr"></div>'
					+ '</li>';
				
			} else {
				var clickHtml = ' onclick="locl.pages.entries.editItem(' + item.id + ');"';
				itemhtml = '<li class="item' + item.id + classext + '' + readstate + '">'
					+ '<div class="check"'+clickHtml+'>' + item.date
					+ '</div><div class="title"'+clickHtml+'>' + item.name + '<span class="small counter'+item.id+'"><br />' + item.bezirk + '</span></div><div class="clr"></div>'
					+ '</li>';
			}
		
			html += itemhtml;
			
		}
				
			
		if( goto<data.length ) html += '<li onclick="locl.pages.entries.loadNext();" class="removeme"><div align="center">Nchsten ' + perpage + ' laden</div></li>';
		
		if( append==true ) {
			$(".inner-scroller .innerhtml li.removeme", "#" + $.mobile.activePage.attr("id") ).remove();
			$(".inner-scroller .innerhtml ul", "#" + $.mobile.activePage.attr("id") ).append( html );
			
			//refresh scroller
			var scroller = locl.getPageScroller();
			if( scroller ) scroller.refresh();
			locl.hideLoading();
			return;
		}


		render_done( '<ul class="items">' + html + '</ul>' );
		
	}
	
	function render_done( html ) {
		$(".inner-scroller .innerhtml", "#page" ).html( html );

		setTimeout( function() {
		var scroller = locl.getPageScroller();
			if( scroller ) scroller.refresh();
		}, 100);
		
		if( !locl.doNotCloseSlider ) locl.hideLoading();	
	}

	locl.pages.register("entries", page);
	$(document).bind("mobileinit", function () {
		locl.pages.entries.init();
	})
} (locl, amplify));






(function (locl, amplify, undefined) {
	var page = locl.pages.entriesdetail = {
		id:0,
		init:function() {
			amplify.subscribe("page.entriesdetail.imageready", onImageReady);
		},
		ready: function() {
		},
		open: function() {
		},
		OpenUrl: function() {
			var link = $("#link", "#entriesdetail").val();
			
			if( link!="" ) {
				locl.openURL( link );	
				
			}
			
			
		},
		moveDown: function() {
			var cid = locl.pages.entriesdetail.id;
			if( cid==undefined || cid=="" || cid==0 ) return;
			
			var data = locl.db.getEntries();
			var goto = 0;
			
			for( var i=0; i<data.length; i++ ) {
				if( data[i].id==cid ) break;
			}
			
			if( data[(i+1)] ) goto = data[(i+1)].id;
			
			if( goto==0 ) return;
			locl.pages.entriesdetail.loadItem( goto );
			
		},
		moveUp: function() {
			var cid = locl.pages.entriesdetail.id;
			if( cid==undefined || cid=="" || cid==0 ) return;
			
			var data = locl.db.getEntries();
			var goto = 0;
			var nextitem = false;
			for( var i=0; i<data.length; i++ ) {
				if( data[i].id==cid ) break;
			}

			if( data[(i-1)] ) goto = data[(i+-1)].id;

			if( goto==0 ) return;
			locl.pages.entriesdetail.loadItem( goto );
			
		},
		saveItem: function() {
			if( locl.lastPage=="nearme" ) {
				$.mobile.changePage( "#nearme", {transition: "slide",reverse: true} );			
			} else {
				$.mobile.changePage( "#page", {transition: "slide",reverse: true} );			
				
			}
			
		},
		opened: function (params) {
			$("#toolbar h1").html( "Details" );
						
			setTimeout( function() {
				locl.iScrollReset();
			}, 100);

		},
		loadItem: function( id ) {
			//remove read flag
			$("ul li.item" + id, "#page" ).removeClass( "unread" );
			//data-direction="reverse"
			

			locl.pages.entriesdetail.id = id;
			
			var data = locl.db.getDataFromID( locl.db.getEntries(), id );

			$("#name", "#entriesdetail").html( data.name );
			$("#id", "#entriesdetail").val( id );
			$("#date", "#entriesdetail").html( "Datum: " + data.date );
			$("#beschreibung", "#entriesdetail").html( data.beschreibung );
			
			var html = "";
			if( data.einsatz!="" ) html = 'Einsatz: ' + data.einsatz + '<br />';
			if( data.einsatzart!="" ) html += 'Einsatzart: ' + data.einsatzart + '<br />';
			if( data.bezirk!="" ) html += 'Bezirk: ' + data.bezirk + '<br />';
			if( data.dauer!="" ) html += 'Dauer: ' + data.dauer + '<br />';
			if( data.alarmstufe!="" ) html += 'Alarmstufe: ' + data.alarmstufe + '<br />';
			html += '<br />Feuerwehren:<br />'
					+ data.feuerwehren + '<br />';
			$("#info", "#entriesdetail").html( html );
			$("#link", "#entriesdetail").val( data.link );

			
			if( data.google_link!="" && (data.maps_link=="" || data.maps_link==undefined) ) {
				
				$("#google_link").html( '<a href="#" class="button" onclick="locl.openURL(' + "'" + data.google_link + "'" + ');">Auf Google anzeigen</a>' );
				
			} else {
				$("#google_link").html("");
				
			}

			

			var iimage = data.maps_link;			
			if( iimage!="" && iimage!=undefined ) {
				
				//if( locl.isPhoneGap || !locl.isMobile ) {
					iimage = data.maps_link; //'images/image_placeholder.png';
				//} else {
				//	iimage = locl.getRootFS() + '/ffinfo/' + data.image_name;
				//}
				
				if( data.google_link!="" ) {
					$("#image","#entriesdetail").html( '<a href="#" onclick="locl.openURL(' + "'" + data.google_link + "'" + ');"><img src="' + iimage + '" /></a>' );	
				} else {
					$("#image","#entriesdetail").html( '<img src="' + iimage + '" />' );	
					
				}
				
			} else {
				$("#image","#entriesdetail").html( '' );	
				
				
			}
			
			var read = locl.db.getReadEntries();
			if( !checkData( read ) ) {
				read = new Array();
				read.push( {id:data.id} );	
			} else {
				var found=false;
				for( var i=0; i<read.length; i++ ) {
					if( read[i].id==data.id ) {
						found=true;
						break;
					}
				}
				if( found==false ) {
					read.push( {id:data.id} );
				}
			}
			locl.db.saveReadEntries( read );
			
			
		}
		
	};   
	
	function onImageReady( obj ) {
		var fs = locl.getRootFS();
		var newfile = obj.replace( fs, "" );
		
		locl.pages.entriesdetail.saveImage( newfile );
		
	}
	
	
	locl.pages.register("entriesdetail", page);
	$(document).bind("mobileinit", function () {
		locl.pages.entriesdetail.init();
	})
} (locl, amplify));













(function (locl, amplify, undefined) {
	var settings = locl.user = {
		init: function() {
			amplify.subscribe("app.user", onFeed1);
			amplify.subscribe("app.user.get", onJSONGet);
			amplify.subscribe("app.user.error", onJSONError)  //json.success
			amplify.subscribe("app.user.offline", onSystemOffline);			
			amplify.subscribe("app.user.online", onSystemOnline);			
		},
		getUserId: function() {
			var settings = locl.db.getSettings();
			if( settings )
				return settings.loginEmailAddress;
			return "";
		},
		isLogged: function() {
			var settings = locl.db.getSettings();
			if( settings ) {
				if( settings.loginEmailAddress=="" ) {
					return false;
				} else {
					return true;	
				}
			}
			return false;
			
		},
		loadSettings: function() {
			locl.user.updateState();
		},
		updateState: function() {
		},
		doLogin: function() {
			//do login
			var username = $("#email").val();
			var password = $("#pwd").val();
			
			if( username=="b" && password=="b" ) {
				loginProcede( $("#email").val() );
			
				return;
			}
			
			locl.IsOnline( "app.user.online", "app.user.offline" );
			
		},
		doLogout: function() {
			var settings = locl.db.getSettings();
			settings.loginEmailAddress="";
			locl.db.saveSettings(settings);
			
			locl.user.updateState();
			
			debug( "remove tmeplate_logged" );
			removeHeadFile( "template_logged" );
			//document.location.href="";
			
			debug( "refresh template" );
			UpdateCurrentTemplate();
			
			debug( "logged out" );
			setTimeout( function() {
			$.mobile.changePage( "#page" );
			}, 100);

		},
		forgotPass: function() {
			var url = locl.config.serverUrl + "redir_forgot.php";
			locl.openURL( url );	
		}
	};
	function onFeed1() {}
	function onReady() {
		locl.user.loadSettings();	
	}
	function onJSONError( msg ) {
		locl.onJSONError( msg );
	}
	
	function onSystemOffline( msg ) {
		locl.onJSONError( msg );
	}
	function onSystemOnline() {
		var username = $("#email").val();
		var password = $("#pwd").val();
		
		if( username=="b" && password=="b" ) {
			loginProcede( $("#email").val() );
		
			return;
		}
		
		debug("doLogin");
		locl.showLoading( g("_LANG_TRY_TO_LOGIN") ); //"Benutzeranmeldung wird versucht..." );
		
		amplify.request({
				resourceId: "app.user",
				data: {
				appId: locl.config.appId,
				usedb: locl.config.useDB,
				loadLastMonth: locl.config.loadLastMonth,
				uid: username,
				pwd: password
			},
				success: function (data) {
				debug("app.user.get");
				amplify.publish("app.user.get", data);
			},
				error: function (msg) {
				debug("error user");
				amplify.publish("app.user.error")
			}
		});
	}
	function loginProcede() {
		
		var settings = locl.db.getSettings();
		settings.loginEmailAddress = $("#email").val();
		locl.db.saveSettings( settings );
		
		locl.user.updateState();

		addCSS( "templates/" + template + "/template_logged.css", "template_logged" );
		
		
		locl.settings.updateSettings();

		setTimeout( function() {
			$.mobile.changePage( "#page" );
		}, 200 );
		
		debug( "logged in" );		
		//document.location.href="";		
	}
	function onJSONGet( data ) {
		var success = data[0].success;
		var size = data[0].size/1024;
		debug( "onJSONGet: User (" + size.toFixed(1) + "kb)" );
		if( success=="true" ) {
			debug("login Done");
		
			loginProcede( $("#email").val() );
			
			


		} else {
			locl.msg( "", g("_LANG_USER_NOT_CORRECT") );
			
			locl.user.doLogout();
			
			debug("login failed");
		}
		
		locl.hideLoading();
		
	}

	amplify.subscribe("user.init", onReady);
	
	$(document).bind("mobileinit", function () {
		locl.user.init();
	})

} (locl, amplify));






(function (locl, amplify, undefined) {
	var dumb_data = [];
	var db = locl.db = {
		getColors: function() {
			return ["#FFFEDD","#FFE8E9","#FCFCFB","#EAE6FF","#FFE8FF","#FEEBDE"];
		},
		getAll: function() {
			locl.pages.entries.offset=0;
			locl.showLoading( "Daten werden geladen..." );
			
			setTimeout( function() {
			locl.connector.checkData( true );
			}, 100 );

			
		},
		clearAll: function() {
			debug( "clear all" );
			locl.db.saveEntries("");
			locl.db.saveReadEntries("");
			locl.db.saveSettings("");
			locl.db.saveLastId( undefined );
			
			locl.pages.entries.render();
			
			$("#settings_overlay").hide();
			$.mobile.changePage("#page", {transition: "flip", reverse: true});
			
		},
		saveLastId: function( id ) {
			amplify.store( "LastId", id );
		},
		getLastId: function() {
			return amplify.store( "LastId" );
		},
		getEntriesNearMe: function() {
			return amplify.store( "nearme") ;
		},
		saveEntriesNearMe: function( data ) {
			amplify.store( "nearme", data );
		},
		saveReadEntries: function( data ) {
			amplify.store( "entriesread", data );
		},
		getReadEntries: function() {
			return amplify.store( "entriesread" );
		},
		saveEntries: function( data ) {
			amplify.store( "entries", data );
		},
		getEntries: function() {
			return amplify.store( "entries" );
		},
		savePosition: function( lon, lat ) {
			amplify.store( "pos_lon", lon );
			amplify.store( "pos_lat", lat );
		},
		getPosition: function( opt ) {
			return amplify.store( "pos_" + opt );
		},
		saveLastGeoTS: function( data ) {
			amplify.store("geots", data);
		},
		getLastGeoTS: function() {
			return amplify.store("geots");
		},
		setValue: function( name, val ) {},
		getValue: function( name ) {},
		saveState: function (page, view, value) {},
		getState: function (callback) {},
		saveSettings: function (settings) {amplify.store( "settings", settings );},
		getRootpath: function() {return amplify.store( "rootpath" );},
		saveRootpath: function() {amplify.store( "rootpath", locl.rootFS );},
		saveRootpathOld: function(fs) {amplify.store( "rootpathold", fs );},
		getRootpathOld: function() {return amplify.store( "rootpathold" );},
		getSettings: function () {
			var settings = amplify.store( "settings" );
			if( !settings ) {
				settings = {};
				settings.loginEmailAddress="";
				settings.currentLanguage="";
				settings.PageColor="";
				
			}
			return settings;
			
		},
		saveWithId: function( id, newdata ) {
			var data = locl.db.getEntries();
			if( !checkData( data ) ) return;
			for( i=0;i<data.length;i++) {
				if( data[i].id==id ) 
					data[i] = newdata;	
			}
			locl.db.saveEntries( data );			
		},
		getDataFromID: function( data, id ) {
			
			if( !checkData( data ) ) return;
			
			for( i=0;i<data.length;i++) 
				if( data[i].id==id ) return data[i];
				
			return [];
			
		},
		getId: function( id ) {
			
			var data = locl.db.getEntries();
			if( !checkData( data ) ) return;
			
			for( i=0;i<data.length;i++) 
				if( data[i].id==id ) return i;
				
			return -1;
			
		},
		getNewIdx: function() {
			var data = locl.db.getEntries();
			if( !checkData( data ) ) return 1;
			
			var maxid=1;
			for( var i=0; i<data.length; i++ ) {
				if( data[i].id>maxid ) maxid = data[i].id;
			}
			return (maxid+1);
		}

	}
} (locl, amplify));















(function (locl, amplify, undefined) {
	var settings = locl.language = {
		load: function ( lang ) {
			locl.language.apply();
		},
		confirm: function( newVal ) {
			locl.language.choosen = newVal;
			
			$(".main").hide();
			$(".besure").css( { display:"block", visibility:"visible" } );
			
		},
		save: function () {
			var newVal = locl.language.choosen;
			if( newVal==undefined || newVal =="" ) newVal = "de";
			
			locl.showLoading( g("_LANG_RENDER_LIST") );
			
			var settings = locl.db.getSettings();
			settings.currentLanguage=newVal;
			language = newVal;
			locl.settings.language = newVal;
			locl.db.saveSettings(settings);
					
			$.mobile.changePage( "#page" );

			$("#settings_overlay").hide();

			$(".main").show();
			$(".besure").hide();
						
			removeHeadFile( "language" );
			loadLanguage();
			
			
		},
		loadFix: function() {
			addCSS( "templates/" + locl.template + "/templatefix_" +  language + ".css", "language_fix" );
		},
		apply: function() {
			
			//apply language
			var data = [];
			if( language=="cs" ) {
				data = language_data_cs;
			} else {
				data = language_data_de;
			}
			var cache = locl.language.cache;
			if( !cache ) 
				cache = [];	
			
			for( var i=0; i<data.length; i++ ) {
				for( var key in data[i] ) {
					var value = data[i][key];
					$("." + key).html( value );
					$("." + key).val( value );
					
					cache[ key ] = value;
				}

			}
			
			locl.language.loadFix();
			locl.language.cache = cache;	
			
		},
		getSetting: function() {
			var settings = locl.db.getSettings();
			if( settings ) return settings.currentLanguage;
		}
	};	
} (locl, amplify));












(function (locl, amplify, undefined) {
	var page = locl.settings = {
		ready: function() {
		},
		updateSettings: function() {
		},
		load: function () {
			amplify.publish("settings.ready");			
		},
		save: function () {
			var settings = locl.db.getSettings();
			settings.loginEmailAddress = locl.settings.loginEmailAddress
			locl.db.saveSettings(settings)
		},
		LoadSettingsPage: function() {
									
			//collect size data
			var data, html = '<h1 style="margin:0;padding:0;">Speicherstatistik</h1>';
			
			$("#sizeStat").html( html );
			
			$.mobile.changePage( "#settings" );	
		},
		SaveSettingsPage: function() {
			locl.settings.load();
			locl.user.doLogin();
		}
	};
	function onReady() {
		locl.settings.load();
		//locl.IsOnline( "app.page.online", "app.page.offline" );
		

	}
	function populate(savedSettings) {
	}
	locl.pages.register("settings", page);
	amplify.subscribe("core.init", onReady);
	
} (locl, amplify));




(function (amplify, undefined) {
	amplify.request.define("app.connector.send", "ajax", {
		url: locl.config.baseAPIUrl + "send/?appid=" + locl.version,
		type: "POST",
		timeout: 10000,
		decoder: function (data, status, xhr, success, error) {	
			success();
		}
	});
} (amplify));



(function (amplify, undefined) {
	amplify.request.define("app.err", "ajax", {
		url: locl.config.baseAPIUrl + "alert/?appid=" + locl.version,
		type: "POST",
		timeout: 10000,
		decoder: function (data, status, xhr, success, error) {	
			success();
		}
	});
} (amplify));




(function (amplify, undefined) {
	amplify.request.define("app.connector.receive", "ajax", {
		url: locl.config.baseAPIUrl + "receive/?appid=" + locl.version,
		dataType: "jsonp",
		jsonp: "callback",
		type: "GET",
		timeout: 10000,
		decoder: function (data, status, xhr, success, error) {	
			if( !locl.checkData( data, error, "Connector Rcv" ) ) return;
			if (data && data.result == true) {
				debug( "decoder:Start" );
				
				var records = [];
				if (!_.isString(data.data)) {					
					for (ind in data.data) {
						var record = data.data[ind];						
						records.push({
							id: record.id,
							name: record.name,
							date:record.date,
							beschreibung: record.beschreibung,
							einsatz: record.einsatz,
							einsatzart: record.einsatzart,
							bezirk: record.bezirk,
							dauer: record.dauer,
							alarmstufe: record.alarmstufe,
							feuerwehren: record.feuerwehren,
							link: record.link,
							e: record.e,
							n: record.n,
							google_link: record.google_link,
							save_geo: record.save_geo,
							image_name: record.image_name,
							image: record.image,
							maps_link: record.maps_link,
							werbung: record.werbung

						})
					}
				}				
				locl.infoOffline();
				success(records);
			} else {
				locl.parseError(data, error, "decoder Connector Rcv");
			}
		}
	});
} (amplify));



(function (amplify, undefined) {
	amplify.request.define("app.nearme.receive", "ajax", {
		url: locl.config.baseAPIUrl + "nearme/?appid=" + locl.version,
		dataType: "jsonp",
		jsonp: "callback",
		type: "GET",
		timeout: 10000,
		decoder: function (data, status, xhr, success, error) {	
			if( !locl.checkData( data, error, "Connector Rcv" ) ) return;
			if (data && data.result == true) {
				debug( "decoder:Start" );
				
				var records = [];
				if (!_.isString(data.data)) {					
					for (ind in data.data) {
						var record = data.data[ind];						
						records.push({
							id: record.id,
							name: record.name,
							date:record.date,
							beschreibung: record.beschreibung,
							einsatz: record.einsatz,
							einsatzart: record.einsatzart,
							bezirk: record.bezirk,
							dauer: record.dauer,
							alarmstufe: record.alarmstufe,
							feuerwehren: record.feuerwehren,
							link: record.link,
							e: record.e,
							n: record.n,
							google_link: record.google_link,
							save_geo: record.save_geo,
							image_name: record.image_name,
							image: record.image,
							maps_link: record.maps_link,
							werbung: record.werbung,
							distance: record.distance

						})
					}
				}				
				locl.infoOffline();
				success(records);
			} else {
				locl.parseError(data, error, "decoder Connector Rcv");
			}
		}
	});
} (amplify));




(function (amplify, undefined) {
	amplify.request.define("app.user", "ajax", {
		url: locl.config.baseAPIUrl + "user/?appid=" + locl.version,
		dataType: "jsonp",
		jsonp: "callback",
		type: "GET",
		timeout: 10000,
		decoder: function (data, status, xhr, success, error) {	
			if( !locl.checkData( data, error, g("_LANG_DO_LOGIN") ) ) return;
			if (data && data.result == true) {
				debug( "decoder:Start" );
				
				var records = [];
				var configrecords = [];
				if (!_.isString(data.data)) {					
					for (ind in data.data) {
						var record = data.data[ind];						
						records.push({
							id: record.id,
							success: record.success
						})
					}
				}				
				debug("decoder:success:");
				locl.infoOffline();
				success(records, configrecords);
			} else {
				debug( "decoder:error: "+error );
				locl.parseError(data, error, "decoder Anmeldung");
			}
		}
	});
} (amplify));







function reindexArray( arr )
{
       var result = [];
        for( var key in arr )
                result.push( arr[key] );
        return result;
};

function makeMC() {
	var idx = [], itoh = '0123456789ABCDEF'.split('');

    for (var i = 0; i<36; i++) {
		idx[i] = 0xf & Math.random() * 0x10;
	}
	
    idx[14] = 4;
    idx[19] = (idx[19] & 0x3) | 0x8;

    for (var i = 0; i<36; i++) {
		idx[i] = itoh[idx[i]];
	}
    idx[8] = idx[13] = idx[18] = idx[23] = '-';
    return idx.join('');
}

function g( key ) {
	if( !locl.language.cache ) return;

	var data = locl.language.cache;
	return data[ key ];
}

function findArray(arr, obj) { 
	for(var i=0; i<arr.length; i++) { 
		if (arr[i] == obj) return true; 
	} 
} 

function formatNumber( num ) {
	num = num.toString().replace( /\,/, '.' );
	num = parseFloat( num );
	
	num = num.toFixed(2);
	num = num.toString().replace( /\./, ',' );
	return num;
}
function debug( lt ) {
	return;
	var currentTimeAndDate = new Date();
	var html = $("#debug").html();
	html = lt + "<br />" + html;
	$("#debug").html( html );
}


(function (locl, amplify, undefined) {
	var page = locl.validator = {
		validateNumber: function( val ) {
			
			return !isNaN(parseFloat(val)) && isFinite(val);

			
		},
		validateField: function( input, title, message ) {
			obj = $("#" + input, "#" + locl.pageId);
			
			if( obj.val() == "" || obj.val() == obj.attr("title") ) {
				locl.validator.throwError( message );
				return false;
			}
			return true;

		},
		validateEMail: function( val ) {			
			var re = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
	
			if( re.test(val) ) {
				return true;
			} else {
				return false;
			}
			
		},
		throwError: function( message ) {
			locl.msg("Fehlerhafte Eingabe", message, "error")	
		}
	};
} (locl, amplify));
