var pushCode = "C9A64-5CEDD";
var pushName = "FFInfoOOE";
var senderId = "1031703603831";

function pushInit() {


	try 
	{ 
		pushNotification = window.plugins.pushNotification;
		
		if( (/android/gi).test(navigator.appVersion) ) { // (device.platform == 'android' || device.platform == 'Android') {
			pushNotification.register(successHandler, errorHandler, {"senderID":senderId,"ecb":"onNotificationGCM",pw_appid:pushCode, appname:pushName});		// required!
		} else {
			pushNotification.register(tokenHandler, errorHandler, {"badge":"true","sound":"true","alert":"true","ecb":"onNotificationAPN"});	// required!
		}
	}
	catch(err) 
	{ 
		txt="There was an error on this page.\n\n"; 
		txt+="Error description: " + err.message + "\n\n"; 
		
		//locl.user.savePush( "TEST Push" );
		//alert(txt); 
	} 
	
	
}

function alertMe() {
	locl.msg( "", "Es ist ein neuer Eintrag verfgbar", "info" );
	
}


// handle APNS notifications for iOS
function onNotificationAPN(e) {
	
	alertMe();
	
	
	if (e.alert) {
		 //navigator.notification.alert(e.alert);
	}
		
	if (e.sound) {
		var snd = new Media(e.sound);
		snd.play();
	}
	
	if (e.badge) {
		pushNotification.setApplicationIconBadgeNumber(successHandler, e.badge);
	}
}


// handle GCM notifications for Android
function onNotificationGCM(e) {
	switch( e.event )
	{
		case 'registered':
			if ( e.regid.length > 0 ) {
				// Your GCM push server needs to know the regID before it can push to this device
				// here is where you might want to send it the regID for later use.
				//locl.user.savePush( e.regid );
				
				PushWoosh.appCode = pushCode;
				PushWoosh.register(e.regid, function(data) {
						 //alert("PushWoosh register success: " + JSON.stringify(data));
	
						 
						 
						 
					 }, function(errorregistration) {
						 //alert("Couldn't register with PushWoosh" +  errorregistration);
					 });
				
	
			}
			break;
		
		case 'message':
			// if this flag is set, this notification happened while we were in the foreground.
			// you might want to play a sound to get the user's attention, throw up a dialog, etc.
			if (e.foreground) {
				alertMe();
				
				// if the notification contains a soundname, play it.
				var my_media = new Media("/android_asset/www/"+e.soundname);
				my_media.play();
			} else {	// otherwise we were launched because the user touched a notification in the notification tray.
				alertMe();
			}
			
			break;
		
		case 'error':			
			break;
		default:
			break;
	}
}


/* handler for IOS*/
function tokenHandler (result) {
	PushWoosh.appCode = pushCode;
	PushWoosh.register(result, function(data) {
		//alert("PushWoosh register success: " + JSON.stringify(data));
		//locl.user.savePush( result );
		
	}, function(e) {
		//alert("Couldn't register with PushWoosh" +  e);
	});

}

/* handler for Android and others */
function successHandler (e) {

}

function errorHandler (e) {
	locl.msg( "", e, "error" );
}

		
		
		